Index: benchmark/edge_lookup.cc
===================================================================
--- benchmark/edge_lookup.cc	(revision 2391)
+++ benchmark/edge_lookup.cc	(revision 2510)
@@ -30,5 +30,5 @@
   {
   public:
-    GRAPH_TYPEDEFS(typename G)
+    GRAPH_TYPEDEFS(typename G);
     typedef G Graph;
 
@@ -108,5 +108,5 @@
   {
   public:
-    GRAPH_TYPEDEFS(typename G)
+    GRAPH_TYPEDEFS(typename G);
     typedef G Graph;
 
@@ -195,5 +195,5 @@
 //   {
 //   public:
-//     GRAPH_TYPEDEFS(typename G)
+//     GRAPH_TYPEDEFS(typename G);
 //     typedef G Graph;
     
@@ -288,5 +288,5 @@
 //   {
 //   public:
-//     GRAPH_TYPEDEFS(typename G)
+//     GRAPH_TYPEDEFS(typename G);
 //     typedef G Graph;
     
@@ -378,5 +378,5 @@
 //   };
 
-GRAPH_TYPEDEFS(SmartGraph)
+GRAPH_TYPEDEFS(SmartGraph);
 typedef SmartGraph Graph;
 
Index: demo/graph_orientation.cc
===================================================================
--- demo/graph_orientation.cc	(revision 2391)
+++ demo/graph_orientation.cc	(revision 2510)
@@ -26,5 +26,5 @@
 using namespace lemon;
  
-GRAPH_TYPEDEFS(ListGraph)
+GRAPH_TYPEDEFS(ListGraph);
 
 int main(int argc, char** argv) 
Index: demo/strongly_connected_orientation.cc
===================================================================
--- demo/strongly_connected_orientation.cc	(revision 2391)
+++ demo/strongly_connected_orientation.cc	(revision 2510)
@@ -43,5 +43,5 @@
 
 typedef SmartUGraph UGraph;
-UGRAPH_TYPEDEFS(UGraph)
+UGRAPH_TYPEDEFS(UGraph);
 
 Color color(bool c) {
Index: lemon/graph_utils.h
===================================================================
--- lemon/graph_utils.h	(revision 2485)
+++ lemon/graph_utils.h	(revision 2510)
@@ -50,5 +50,5 @@
   ///\note If \c G it a template parameter, it should be used in this way.
   ///\code
-  ///  GRAPH_TYPEDEFS(typename G)
+  ///  GRAPH_TYPEDEFS(typename G);
   ///\endcode
   ///
@@ -61,5 +61,5 @@
     typedef Graph::   EdgeIt    EdgeIt;			\
     typedef Graph:: InEdgeIt  InEdgeIt;			\
-    typedef Graph::OutEdgeIt OutEdgeIt;			
+    typedef Graph::OutEdgeIt OutEdgeIt
 
   ///Creates convenience typedefs for the undirected graph types and iterators
@@ -71,5 +71,5 @@
   ///\note If \c G it a template parameter, it should be used in this way.
   ///\code
-  ///  UGRAPH_TYPEDEFS(typename G)
+  ///  UGRAPH_TYPEDEFS(typename G);
   ///\endcode
   ///
@@ -77,8 +77,8 @@
   ///template typedefs in C++.
 #define UGRAPH_TYPEDEFS(Graph)				\
-  GRAPH_TYPEDEFS(Graph)						\
+  GRAPH_TYPEDEFS(Graph);				\
     typedef Graph:: UEdge   UEdge;			\
     typedef Graph:: UEdgeIt UEdgeIt;			\
-    typedef Graph:: IncEdgeIt   IncEdgeIt;		       
+    typedef Graph:: IncEdgeIt   IncEdgeIt
 
   ///\brief Creates convenience typedefs for the bipartite undirected graph 
@@ -91,5 +91,5 @@
   ///\note If \c G it a template parameter, it should be used in this way.
   ///\code
-  ///  BPUGRAPH_TYPEDEFS(typename G)
+  ///  BPUGRAPH_TYPEDEFS(typename G);
   ///\endcode
   ///
@@ -97,9 +97,9 @@
   ///template typedefs in C++.
 #define BPUGRAPH_TYPEDEFS(Graph)            \
-  UGRAPH_TYPEDEFS(Graph)                    \
+  UGRAPH_TYPEDEFS(Graph);		    \
     typedef Graph::ANode ANode;             \
     typedef Graph::BNode BNode;             \
     typedef Graph::ANodeIt ANodeIt;	    \
-    typedef Graph::BNodeIt BNodeIt;
+    typedef Graph::BNodeIt BNodeIt
 
   /// \brief Function to count the items in the graph.
@@ -2493,5 +2493,5 @@
   {
   public:
-    GRAPH_TYPEDEFS(typename G)
+    GRAPH_TYPEDEFS(typename G);
     typedef G Graph;
 
@@ -2609,5 +2609,5 @@
     using EdgeLookUp<G>::_head;
 
-    GRAPH_TYPEDEFS(typename G)
+    GRAPH_TYPEDEFS(typename G);
     typedef G Graph;
     
Index: lemon/steiner.h
===================================================================
--- lemon/steiner.h	(revision 2399)
+++ lemon/steiner.h	(revision 2510)
@@ -56,5 +56,5 @@
   public:
     
-    UGRAPH_TYPEDEFS(typename UGraph)
+    UGRAPH_TYPEDEFS(typename UGraph);
 
     typedef typename CostMap::Value Value;