Index: lemon/capacity_scaling.h
===================================================================
--- lemon/capacity_scaling.h	(revision 2509)
+++ lemon/capacity_scaling.h	(revision 2533)
@@ -67,10 +67,10 @@
   /// \author Peter Kovacs
 
-template < typename Graph,
-	   typename LowerMap = typename Graph::template EdgeMap<int>,
-	   typename CapacityMap = LowerMap,
-	   typename CostMap = typename Graph::template EdgeMap<int>,
-	   typename SupplyMap = typename Graph::template NodeMap
-				<typename CapacityMap::Value> >
+  template < typename Graph,
+	     typename LowerMap = typename Graph::template EdgeMap<int>,
+	     typename CapacityMap = LowerMap,
+	     typename CostMap = typename Graph::template EdgeMap<int>,
+	     typename SupplyMap = typename Graph::template NodeMap
+				  <typename CapacityMap::Value> >
   class CapacityScaling
   {
@@ -639,5 +639,5 @@
       }
 #ifdef _DEBUG_ITER_
-      std::cout << "Cost Scaling algorithm finished with running Dijkstra algorithm "
+      std::cout << "Capacity Scaling algorithm finished with running Dijkstra algorithm "
 	<< dijk_num << " times." << std::endl;
 #endif
Index: lemon/circulation.h
===================================================================
--- lemon/circulation.h	(revision 2527)
+++ lemon/circulation.h	(revision 2533)
@@ -374,7 +374,7 @@
     } 
     
-    /// \name Execution control The simplest way to execute the
-    /// algorithm is to use one of the member functions called \c
-    /// run().  
+    /// \name Execution control
+    /// The simplest way to execute the algorithm is to use one of the
+    /// member functions called \c run().
     /// \n 
     /// If you need more control on initial solution or execution then
Index: lemon/cycle_canceling.h
===================================================================
--- lemon/cycle_canceling.h	(revision 2526)
+++ lemon/cycle_canceling.h	(revision 2533)
@@ -87,10 +87,10 @@
   /// \author Peter Kovacs
 
-template < typename Graph,
-	   typename LowerMap = typename Graph::template EdgeMap<int>,
-	   typename CapacityMap = LowerMap,
-	   typename CostMap = typename Graph::template EdgeMap<int>,
-	   typename SupplyMap = typename Graph::template NodeMap
-				<typename CapacityMap::Value> >
+  template < typename Graph,
+             typename LowerMap = typename Graph::template EdgeMap<int>,
+             typename CapacityMap = LowerMap,
+             typename CostMap = typename Graph::template EdgeMap<int>,
+             typename SupplyMap = typename Graph::template NodeMap
+                                  <typename CapacityMap::Value> >
   class CycleCanceling
   {
@@ -324,10 +324,10 @@
 
       // Finding a feasible flow
-      Circulation< Graph, Capacity, ConstMap<Edge, Capacity>,
-	CapacityRefMap, SupplyMap >::DefFlowMap<FlowMap>::Create
-	circulation( graph, constMap<Edge>((Capacity)0),
-		     capacity, supply);
-      circulation.flowMap(flowMap);
-      return circulation.run();
+      Circulation< Graph, ConstMap<Edge, Capacity>, CapacityRefMap,
+		   SupplyMap >
+	circulation( graph, constMap<Edge>((Capacity)0), capacity, 
+		     supply );
+      circulation.flowMap(flow);
+      return circulation.run() == -1;
     }
 
Index: lemon/min_cost_flow.h
===================================================================
--- lemon/min_cost_flow.h	(revision 2509)
+++ lemon/min_cost_flow.h	(revision 2533)
@@ -64,10 +64,10 @@
   /// \author Peter Kovacs
 
-template < typename Graph,
-	   typename LowerMap = typename Graph::template EdgeMap<int>,
-	   typename CapacityMap = LowerMap,
-	   typename CostMap = typename Graph::template EdgeMap<int>,
-	   typename SupplyMap = typename Graph::template NodeMap
-				<typename CapacityMap::Value> >
+  template < typename Graph,
+             typename LowerMap = typename Graph::template EdgeMap<int>,
+             typename CapacityMap = LowerMap,
+             typename CostMap = typename Graph::template EdgeMap<int>,
+             typename SupplyMap = typename Graph::template NodeMap
+                                  <typename CapacityMap::Value> >
   class MinCostFlow :
     public NetworkSimplex< Graph,
Index: lemon/min_cost_max_flow.h
===================================================================
--- lemon/min_cost_max_flow.h	(revision 2515)
+++ lemon/min_cost_max_flow.h	(revision 2533)
@@ -58,7 +58,7 @@
   /// \author Peter Kovacs
 
-template < typename Graph,
-	   typename CapacityMap = typename Graph::template EdgeMap<int>,
-	   typename CostMap = typename Graph::template EdgeMap<int> >
+  template < typename Graph,
+	     typename CapacityMap = typename Graph::template EdgeMap<int>,
+	     typename CostMap = typename Graph::template EdgeMap<int> >
   class MinCostMaxFlow
   {
Index: lemon/network_simplex.h
===================================================================
--- lemon/network_simplex.h	(revision 2509)
+++ lemon/network_simplex.h	(revision 2533)
@@ -94,10 +94,10 @@
   /// \author Peter Kovacs
 
-template < typename Graph,
-	   typename LowerMap = typename Graph::template EdgeMap<int>,
-	   typename CapacityMap = LowerMap,
-	   typename CostMap = typename Graph::template EdgeMap<int>,
-	   typename SupplyMap = typename Graph::template NodeMap
-				<typename CapacityMap::Value> >
+  template < typename Graph,
+             typename LowerMap = typename Graph::template EdgeMap<int>,
+             typename CapacityMap = LowerMap,
+             typename CostMap = typename Graph::template EdgeMap<int>,
+             typename SupplyMap = typename Graph::template NodeMap
+                                  <typename CapacityMap::Value> >
   class NetworkSimplex
   {